<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "https://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<meta http-equiv="Content-Type" content="text/xhtml;charset=UTF-8"/>
<meta http-equiv="X-UA-Compatible" content="IE=9"/>
<meta name="generator" content="Doxygen 1.8.17"/>
<meta name="viewport" content="width=device-width, initial-scale=1"/>
<title>SpaceFighter2020: GameScene Class Reference</title>
<link href="tabs.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="jquery.js"></script>
<script type="text/javascript" src="dynsections.js"></script>
<link href="search/search.css" rel="stylesheet" type="text/css"/>
<script type="text/javascript" src="search/searchdata.js"></script>
<script type="text/javascript" src="search/search.js"></script>
<link href="doxygen.css" rel="stylesheet" type="text/css" />
</head>
<body>
<div id="top"><!-- do not remove this div, it is closed by doxygen! -->
<div id="titlearea">
<table cellspacing="0" cellpadding="0">
 <tbody>
 <tr style="height: 56px;">
  <td id="projectalign" style="padding-left: 0.5em;">
   <div id="projectname">SpaceFighter2020
   </div>
   <div id="projectbrief">This documentation reffers to the game Space Fighter 2020 created for pa2 course. Game is side-scrolling shooter where the goal is to get on the end of the level and kill as much as enemy ships as possible. Player can pick up bonuses for repairing point of health or upgrading his weapons.</div>
  </td>
 </tr>
 </tbody>
</table>
</div>
<!-- end header part -->
<!-- Generated by Doxygen 1.8.17 -->
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
var searchBox = new SearchBox("searchBox", "search",false,'Search');
/* @license-end */
</script>
<script type="text/javascript" src="menudata.js"></script>
<script type="text/javascript" src="menu.js"></script>
<script type="text/javascript">
/* @license magnet:?xt=urn:btih:cf05388f2679ee054f2beb29a391d25f4e673ac3&amp;dn=gpl-2.0.txt GPL-v2 */
$(function() {
  initMenu('',true,false,'search.php','Search');
  $(document).ready(function() { init_search(); });
});
/* @license-end */</script>
<div id="main-nav"></div>
<!-- window showing the filter options -->
<div id="MSearchSelectWindow"
     onmouseover="return searchBox.OnSearchSelectShow()"
     onmouseout="return searchBox.OnSearchSelectHide()"
     onkeydown="return searchBox.OnSearchSelectKey(event)">
</div>

<!-- iframe showing the search results (closed by default) -->
<div id="MSearchResultsWindow">
<iframe src="javascript:void(0)" frameborder="0" 
        name="MSearchResults" id="MSearchResults">
</iframe>
</div>

</div><!-- top -->
<div class="header">
  <div class="summary">
<a href="#pub-methods">Public Member Functions</a> &#124;
<a href="#pub-static-methods">Static Public Member Functions</a> &#124;
<a href="#pri-methods">Private Member Functions</a> &#124;
<a href="#pri-attribs">Private Attributes</a> &#124;
<a href="classGameScene-members.html">List of all members</a>  </div>
  <div class="headertitle">
<div class="title">GameScene Class Reference</div>  </div>
</div><!--header-->
<div class="contents">

<p>Mayer singlton class of <a class="el" href="classGameScene.html" title="Mayer singlton class of GameScene, keeps track of all GameObjects. Updates GameObjects,...">GameScene</a>, keeps track of all GameObjects. Updates GameObjects, resolves collisions using <a class="el" href="classCollisionVisitor.html" title="Abstract class of double dispatch visitor design patter.">CollisionVisitor</a>.  
 <a href="classGameScene.html#details">More...</a></p>

<p><code>#include &lt;<a class="el" href="GameScene_8h_source.html">GameScene.h</a>&gt;</code></p>
<div class="dynheader">
Collaboration diagram for GameScene:</div>
<div class="dyncontent">
<div class="center"><img src="classGameScene__coll__graph.png" border="0" usemap="#GameScene_coll__map" alt="Collaboration graph"/></div>
<map name="GameScene_coll__map" id="GameScene_coll__map">
<area shape="rect" title="Mayer singlton class of GameScene, keeps track of all GameObjects. Updates GameObjects,..." alt="" coords="63,336,163,363"/>
<area shape="rect" href="classPlayer.html" title="Represent player, takes user input." alt="" coords="81,247,144,273"/>
<area shape="rect" href="classEntity.html" title="Abstract class representing GameObjects that have weapon and health." alt="" coords="83,171,143,197"/>
<area shape="rect" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties." alt="" coords="5,81,108,108"/>
<area shape="rect" href="classObject.html" title="Abstract class that manages position, rendering of it self and allows for memory managment by GameSce..." alt="" coords="25,5,89,32"/>
<area shape="rect" href="classWeapon.html" title="Factory styled class for creating projectiles." alt="" coords="133,81,207,108"/>
</map>
<center><span class="legend">[<a href="graph_legend.html">legend</a>]</span></center></div>
<table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-methods"></a>
Public Member Functions</h2></td></tr>
<tr class="memitem:add5bc48c372aaa7f526c02558a8adf00"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#add5bc48c372aaa7f526c02558a8adf00">~GameScene</a> ()</td></tr>
<tr class="memdesc:add5bc48c372aaa7f526c02558a8adf00"><td class="mdescLeft">&#160;</td><td class="mdescRight">Destroy the Game Scene object and delete all alocated resources.  <a href="classGameScene.html#add5bc48c372aaa7f526c02558a8adf00">More...</a><br /></td></tr>
<tr class="separator:add5bc48c372aaa7f526c02558a8adf00"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4c248243bbb2e5fe84ce8cc8b2594ee1"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#a4c248243bbb2e5fe84ce8cc8b2594ee1">Start</a> ()</td></tr>
<tr class="memdesc:a4c248243bbb2e5fe84ce8cc8b2594ee1"><td class="mdescLeft">&#160;</td><td class="mdescRight">Starts game and spawns player.  <a href="classGameScene.html#a4c248243bbb2e5fe84ce8cc8b2594ee1">More...</a><br /></td></tr>
<tr class="separator:a4c248243bbb2e5fe84ce8cc8b2594ee1"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a2649e608763133b6b2d579d9812d88ac"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#a2649e608763133b6b2d579d9812d88ac">AddObject</a> (<a class="el" href="classGameObject.html">GameObject</a> *obj)</td></tr>
<tr class="memdesc:a2649e608763133b6b2d579d9812d88ac"><td class="mdescLeft">&#160;</td><td class="mdescRight">Adds <a class="el" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties.">GameObject</a> to list of GameObjects.  <a href="classGameScene.html#a2649e608763133b6b2d579d9812d88ac">More...</a><br /></td></tr>
<tr class="separator:a2649e608763133b6b2d579d9812d88ac"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:adfa3b78c34506a3eb93d8d5bc50e1e42"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#adfa3b78c34506a3eb93d8d5bc50e1e42">ResolveCollisions</a> (<a class="el" href="classGameObject.html">GameObject</a> *obj)</td></tr>
<tr class="memdesc:adfa3b78c34506a3eb93d8d5bc50e1e42"><td class="mdescLeft">&#160;</td><td class="mdescRight">Iterates over all GameObjects in memory and performs intersection.  <a href="classGameScene.html#adfa3b78c34506a3eb93d8d5bc50e1e42">More...</a><br /></td></tr>
<tr class="separator:adfa3b78c34506a3eb93d8d5bc50e1e42"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a11fd7ac26d1c7962ec44cc599c0aa79d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#a11fd7ac26d1c7962ec44cc599c0aa79d">EndGame</a> ()</td></tr>
<tr class="memdesc:a11fd7ac26d1c7962ec44cc599c0aa79d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Ends game displays score.  <a href="classGameScene.html#a11fd7ac26d1c7962ec44cc599c0aa79d">More...</a><br /></td></tr>
<tr class="separator:a11fd7ac26d1c7962ec44cc599c0aa79d"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ac8684fb646e9ebb6eaf19d5ec31b29bf"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#ac8684fb646e9ebb6eaf19d5ec31b29bf">DrawHUD</a> ()</td></tr>
<tr class="memdesc:ac8684fb646e9ebb6eaf19d5ec31b29bf"><td class="mdescLeft">&#160;</td><td class="mdescRight">Draws overlay, health, weapon level,score.  <a href="classGameScene.html#ac8684fb646e9ebb6eaf19d5ec31b29bf">More...</a><br /></td></tr>
<tr class="separator:ac8684fb646e9ebb6eaf19d5ec31b29bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a3b67d5f252a2bc9c824e057661cca2a0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#a3b67d5f252a2bc9c824e057661cca2a0">AddScore</a> (const int &amp;score)</td></tr>
<tr class="separator:a3b67d5f252a2bc9c824e057661cca2a0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae7d5de577f89b685e5c4a2b374feabd9"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#ae7d5de577f89b685e5c4a2b374feabd9">GetScore</a> () const</td></tr>
<tr class="separator:ae7d5de577f89b685e5c4a2b374feabd9"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pub-static-methods"></a>
Static Public Member Functions</h2></td></tr>
<tr class="memitem:aa3fd70cbab92a1ac9de85beb9dd24df7"><td class="memItemLeft" align="right" valign="top">static <a class="el" href="classGameScene.html">GameScene</a> &amp;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#aa3fd70cbab92a1ac9de85beb9dd24df7">GetInstance</a> ()</td></tr>
<tr class="memdesc:aa3fd70cbab92a1ac9de85beb9dd24df7"><td class="mdescLeft">&#160;</td><td class="mdescRight">Get the Instance object.  <a href="classGameScene.html#aa3fd70cbab92a1ac9de85beb9dd24df7">More...</a><br /></td></tr>
<tr class="separator:aa3fd70cbab92a1ac9de85beb9dd24df7"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-methods"></a>
Private Member Functions</h2></td></tr>
<tr class="memitem:ac53cc300c8896048c0e21c67e49681b9"><td class="memItemLeft" align="right" valign="top">&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#ac53cc300c8896048c0e21c67e49681b9">GameScene</a> ()</td></tr>
<tr class="memdesc:ac53cc300c8896048c0e21c67e49681b9"><td class="mdescLeft">&#160;</td><td class="mdescRight">Private constructor to achiave singleton pattern.  <a href="classGameScene.html#ac53cc300c8896048c0e21c67e49681b9">More...</a><br /></td></tr>
<tr class="separator:ac53cc300c8896048c0e21c67e49681b9"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af6ff668cfba529e1e514b85a4facee69"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#af6ff668cfba529e1e514b85a4facee69">Loop</a> ()</td></tr>
<tr class="memdesc:af6ff668cfba529e1e514b85a4facee69"><td class="mdescLeft">&#160;</td><td class="mdescRight">Game loop updates, renders, resolves, collision, spawn GameObjects.  <a href="classGameScene.html#af6ff668cfba529e1e514b85a4facee69">More...</a><br /></td></tr>
<tr class="separator:af6ff668cfba529e1e514b85a4facee69"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5e20f53569ad897e8f3812370576ef01"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#a5e20f53569ad897e8f3812370576ef01">CollectGarbage</a> ()</td></tr>
<tr class="memdesc:a5e20f53569ad897e8f3812370576ef01"><td class="mdescLeft">&#160;</td><td class="mdescRight">Collects and deletes flaged GameObjects.  <a href="classGameScene.html#a5e20f53569ad897e8f3812370576ef01">More...</a><br /></td></tr>
<tr class="separator:a5e20f53569ad897e8f3812370576ef01"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a154886b7862369bfb149c6ed225e04ef"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#a154886b7862369bfb149c6ed225e04ef">RenderScene</a> ()</td></tr>
<tr class="memdesc:a154886b7862369bfb149c6ed225e04ef"><td class="mdescLeft">&#160;</td><td class="mdescRight">Iterates over GameObjects and renders them.  <a href="classGameScene.html#a154886b7862369bfb149c6ed225e04ef">More...</a><br /></td></tr>
<tr class="separator:a154886b7862369bfb149c6ed225e04ef"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a450f178e458976fe403bfb428bcd4d90"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#a450f178e458976fe403bfb428bcd4d90">UpdateObjects</a> ()</td></tr>
<tr class="memdesc:a450f178e458976fe403bfb428bcd4d90"><td class="mdescLeft">&#160;</td><td class="mdescRight">Iterates iver GameObjets and updates them.  <a href="classGameScene.html#a450f178e458976fe403bfb428bcd4d90">More...</a><br /></td></tr>
<tr class="separator:a450f178e458976fe403bfb428bcd4d90"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a5e93b787452987763998ae17960a2bb0"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#a5e93b787452987763998ae17960a2bb0">DeleteAll</a> ()</td></tr>
<tr class="memdesc:a5e93b787452987763998ae17960a2bb0"><td class="mdescLeft">&#160;</td><td class="mdescRight">Deletes all GameObjects.  <a href="classGameScene.html#a5e93b787452987763998ae17960a2bb0">More...</a><br /></td></tr>
<tr class="separator:a5e93b787452987763998ae17960a2bb0"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:acd9aba7b1e40afa93916271a23c133ca"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#acd9aba7b1e40afa93916271a23c133ca">HandleKey</a> ()</td></tr>
<tr class="memdesc:acd9aba7b1e40afa93916271a23c133ca"><td class="mdescLeft">&#160;</td><td class="mdescRight">Procceses key input.  <a href="classGameScene.html#acd9aba7b1e40afa93916271a23c133ca">More...</a><br /></td></tr>
<tr class="separator:acd9aba7b1e40afa93916271a23c133ca"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:af2617608671f78921b6b066cabe9750a"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#af2617608671f78921b6b066cabe9750a">InitScene</a> ()</td></tr>
<tr class="memdesc:af2617608671f78921b6b066cabe9750a"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initialize scene at start of new game.  <a href="classGameScene.html#af2617608671f78921b6b066cabe9750a">More...</a><br /></td></tr>
<tr class="separator:af2617608671f78921b6b066cabe9750a"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:ae3369c7f60e4f43fe917d9bdb0984ebd"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#ae3369c7f60e4f43fe917d9bdb0984ebd">InitNCurses</a> ()</td></tr>
<tr class="memdesc:ae3369c7f60e4f43fe917d9bdb0984ebd"><td class="mdescLeft">&#160;</td><td class="mdescRight">Initilize ncurses library.  <a href="classGameScene.html#ae3369c7f60e4f43fe917d9bdb0984ebd">More...</a><br /></td></tr>
<tr class="separator:ae3369c7f60e4f43fe917d9bdb0984ebd"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a84ba968799615dd9c19fc3d09541474d"><td class="memItemLeft" align="right" valign="top">void&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#a84ba968799615dd9c19fc3d09541474d">PrintGameOver</a> ()</td></tr>
<tr class="memdesc:a84ba968799615dd9c19fc3d09541474d"><td class="mdescLeft">&#160;</td><td class="mdescRight">Prints game over screen.  <a href="classGameScene.html#a84ba968799615dd9c19fc3d09541474d">More...</a><br /></td></tr>
<tr class="separator:a84ba968799615dd9c19fc3d09541474d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table><table class="memberdecls">
<tr class="heading"><td colspan="2"><h2 class="groupheader"><a name="pri-attribs"></a>
Private Attributes</h2></td></tr>
<tr class="memitem:a3ea8e071bfb2ae13a3e8beb9a335e9bf"><td class="memItemLeft" align="right" valign="top">std::list&lt; <a class="el" href="classGameObject.html">GameObject</a> * &gt;&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#a3ea8e071bfb2ae13a3e8beb9a335e9bf">m_Objects</a></td></tr>
<tr class="separator:a3ea8e071bfb2ae13a3e8beb9a335e9bf"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a4682c7a3cec9a8e0ad8f19c51fa34662"><td class="memItemLeft" align="right" valign="top"><a class="el" href="classPlayer.html">Player</a> *&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#a4682c7a3cec9a8e0ad8f19c51fa34662">m_Player</a></td></tr>
<tr class="separator:a4682c7a3cec9a8e0ad8f19c51fa34662"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:add59861ba980533197f81619b30180a7"><td class="memItemLeft" align="right" valign="top">bool&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#add59861ba980533197f81619b30180a7">m_Loop</a></td></tr>
<tr class="separator:add59861ba980533197f81619b30180a7"><td class="memSeparator" colspan="2">&#160;</td></tr>
<tr class="memitem:a894da41a73977d541d37881b00e92c5d"><td class="memItemLeft" align="right" valign="top">int&#160;</td><td class="memItemRight" valign="bottom"><a class="el" href="classGameScene.html#a894da41a73977d541d37881b00e92c5d">m_Score</a></td></tr>
<tr class="separator:a894da41a73977d541d37881b00e92c5d"><td class="memSeparator" colspan="2">&#160;</td></tr>
</table>
<a name="details" id="details"></a><h2 class="groupheader">Detailed Description</h2>
<div class="textblock"><p>Mayer singlton class of <a class="el" href="classGameScene.html" title="Mayer singlton class of GameScene, keeps track of all GameObjects. Updates GameObjects,...">GameScene</a>, keeps track of all GameObjects. Updates GameObjects, resolves collisions using <a class="el" href="classCollisionVisitor.html" title="Abstract class of double dispatch visitor design patter.">CollisionVisitor</a>. </p>
</div><h2 class="groupheader">Constructor &amp; Destructor Documentation</h2>
<a id="add5bc48c372aaa7f526c02558a8adf00"></a>
<h2 class="memtitle"><span class="permalink"><a href="#add5bc48c372aaa7f526c02558a8adf00">&#9670;&nbsp;</a></span>~GameScene()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">GameScene::~GameScene </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Destroy the Game Scene object and delete all alocated resources. </p>

</div>
</div>
<a id="ac53cc300c8896048c0e21c67e49681b9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac53cc300c8896048c0e21c67e49681b9">&#9670;&nbsp;</a></span>GameScene()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">GameScene::GameScene </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">inline</span><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Private constructor to achiave singleton pattern. </p>

</div>
</div>
<h2 class="groupheader">Member Function Documentation</h2>
<a id="a2649e608763133b6b2d579d9812d88ac"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a2649e608763133b6b2d579d9812d88ac">&#9670;&nbsp;</a></span>AddObject()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::AddObject </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classGameObject.html">GameObject</a> *&#160;</td>
          <td class="paramname"><em>obj</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Adds <a class="el" href="classGameObject.html" title="Abstract class that represents GameObject with collision and movement properties.">GameObject</a> to list of GameObjects. </p>

</div>
</div>
<a id="a3b67d5f252a2bc9c824e057661cca2a0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3b67d5f252a2bc9c824e057661cca2a0">&#9670;&nbsp;</a></span>AddScore()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::AddScore </td>
          <td>(</td>
          <td class="paramtype">const int &amp;&#160;</td>
          <td class="paramname"><em>score</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="a5e20f53569ad897e8f3812370576ef01"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5e20f53569ad897e8f3812370576ef01">&#9670;&nbsp;</a></span>CollectGarbage()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::CollectGarbage </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Collects and deletes flaged GameObjects. </p>

</div>
</div>
<a id="a5e93b787452987763998ae17960a2bb0"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a5e93b787452987763998ae17960a2bb0">&#9670;&nbsp;</a></span>DeleteAll()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::DeleteAll </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Deletes all GameObjects. </p>

</div>
</div>
<a id="ac8684fb646e9ebb6eaf19d5ec31b29bf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ac8684fb646e9ebb6eaf19d5ec31b29bf">&#9670;&nbsp;</a></span>DrawHUD()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::DrawHUD </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Draws overlay, health, weapon level,score. </p>

</div>
</div>
<a id="a11fd7ac26d1c7962ec44cc599c0aa79d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a11fd7ac26d1c7962ec44cc599c0aa79d">&#9670;&nbsp;</a></span>EndGame()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::EndGame </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Ends game displays score. </p>

</div>
</div>
<a id="aa3fd70cbab92a1ac9de85beb9dd24df7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#aa3fd70cbab92a1ac9de85beb9dd24df7">&#9670;&nbsp;</a></span>GetInstance()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classGameScene.html">GameScene</a> &amp; GameScene::GetInstance </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">static</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Get the Instance object. </p>

</div>
</div>
<a id="ae7d5de577f89b685e5c4a2b374feabd9"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae7d5de577f89b685e5c4a2b374feabd9">&#9670;&nbsp;</a></span>GetScore()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">int GameScene::GetScore </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td> const</td>
        </tr>
      </table>
</div><div class="memdoc">

</div>
</div>
<a id="acd9aba7b1e40afa93916271a23c133ca"></a>
<h2 class="memtitle"><span class="permalink"><a href="#acd9aba7b1e40afa93916271a23c133ca">&#9670;&nbsp;</a></span>HandleKey()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::HandleKey </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Procceses key input. </p>

</div>
</div>
<a id="ae3369c7f60e4f43fe917d9bdb0984ebd"></a>
<h2 class="memtitle"><span class="permalink"><a href="#ae3369c7f60e4f43fe917d9bdb0984ebd">&#9670;&nbsp;</a></span>InitNCurses()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::InitNCurses </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Initilize ncurses library. </p>

</div>
</div>
<a id="af2617608671f78921b6b066cabe9750a"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af2617608671f78921b6b066cabe9750a">&#9670;&nbsp;</a></span>InitScene()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::InitScene </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Initialize scene at start of new game. </p>

</div>
</div>
<a id="af6ff668cfba529e1e514b85a4facee69"></a>
<h2 class="memtitle"><span class="permalink"><a href="#af6ff668cfba529e1e514b85a4facee69">&#9670;&nbsp;</a></span>Loop()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::Loop </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Game loop updates, renders, resolves, collision, spawn GameObjects. </p>

</div>
</div>
<a id="a84ba968799615dd9c19fc3d09541474d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a84ba968799615dd9c19fc3d09541474d">&#9670;&nbsp;</a></span>PrintGameOver()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::PrintGameOver </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Prints game over screen. </p>

</div>
</div>
<a id="a154886b7862369bfb149c6ed225e04ef"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a154886b7862369bfb149c6ed225e04ef">&#9670;&nbsp;</a></span>RenderScene()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::RenderScene </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Iterates over GameObjects and renders them. </p>

</div>
</div>
<a id="adfa3b78c34506a3eb93d8d5bc50e1e42"></a>
<h2 class="memtitle"><span class="permalink"><a href="#adfa3b78c34506a3eb93d8d5bc50e1e42">&#9670;&nbsp;</a></span>ResolveCollisions()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::ResolveCollisions </td>
          <td>(</td>
          <td class="paramtype"><a class="el" href="classGameObject.html">GameObject</a> *&#160;</td>
          <td class="paramname"><em>obj</em></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Iterates over all GameObjects in memory and performs intersection. </p>

</div>
</div>
<a id="a4c248243bbb2e5fe84ce8cc8b2594ee1"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4c248243bbb2e5fe84ce8cc8b2594ee1">&#9670;&nbsp;</a></span>Start()</h2>

<div class="memitem">
<div class="memproto">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::Start </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
</div><div class="memdoc">

<p>Starts game and spawns player. </p>

</div>
</div>
<a id="a450f178e458976fe403bfb428bcd4d90"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a450f178e458976fe403bfb428bcd4d90">&#9670;&nbsp;</a></span>UpdateObjects()</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">void GameScene::UpdateObjects </td>
          <td>(</td>
          <td class="paramname"></td><td>)</td>
          <td></td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

<p>Iterates iver GameObjets and updates them. </p>

</div>
</div>
<h2 class="groupheader">Member Data Documentation</h2>
<a id="add59861ba980533197f81619b30180a7"></a>
<h2 class="memtitle"><span class="permalink"><a href="#add59861ba980533197f81619b30180a7">&#9670;&nbsp;</a></span>m_Loop</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">bool GameScene::m_Loop</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">
<p>Game loop flag </p>

</div>
</div>
<a id="a3ea8e071bfb2ae13a3e8beb9a335e9bf"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a3ea8e071bfb2ae13a3e8beb9a335e9bf">&#9670;&nbsp;</a></span>m_Objects</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">std::list&lt;<a class="el" href="classGameObject.html">GameObject</a> *&gt; GameScene::m_Objects</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a4682c7a3cec9a8e0ad8f19c51fa34662"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a4682c7a3cec9a8e0ad8f19c51fa34662">&#9670;&nbsp;</a></span>m_Player</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname"><a class="el" href="classPlayer.html">Player</a>* GameScene::m_Player</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<a id="a894da41a73977d541d37881b00e92c5d"></a>
<h2 class="memtitle"><span class="permalink"><a href="#a894da41a73977d541d37881b00e92c5d">&#9670;&nbsp;</a></span>m_Score</h2>

<div class="memitem">
<div class="memproto">
<table class="mlabels">
  <tr>
  <td class="mlabels-left">
      <table class="memname">
        <tr>
          <td class="memname">int GameScene::m_Score</td>
        </tr>
      </table>
  </td>
  <td class="mlabels-right">
<span class="mlabels"><span class="mlabel">private</span></span>  </td>
  </tr>
</table>
</div><div class="memdoc">

</div>
</div>
<hr/>The documentation for this class was generated from the following files:<ul>
<li>src/<a class="el" href="GameScene_8h_source.html">GameScene.h</a></li>
<li>src/<a class="el" href="GameScene_8cpp.html">GameScene.cpp</a></li>
</ul>
</div><!-- contents -->
<!-- start footer part -->
<hr class="footer"/><address class="footer"><small>
Generated by &#160;<a href="http://www.doxygen.org/index.html">
<img class="footer" src="doxygen.png" alt="doxygen"/>
</a> 1.8.17
</small></address>
</body>
</html>
